unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtDlgs, Math, VCLTee.TeEngine,
  VCLTee.Series, VCLTee.TeeProcs, VCLTee.Chart, VclTee.TeeGDIPlus;

type
  TForm1 = class(TForm)
    Image1: TImage;
    FileOpenBtn: TBitBtn;
    mEdit: TLabeledEdit;
    nEdit: TLabeledEdit;
    S1Edit: TLabeledEdit;
    S2Edit: TLabeledEdit;
    bilateralBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    SorceBtn: TButton;
    OutBtn: TButton;
    RepeatBtn: TButton;
    Label1: TLabel;
    Label2: TLabel;
    extensionBtn: TButton;
    Chart1: TChart;
    Series1: TFastLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure bilateralBtnClick(Sender: TObject);
    procedure SorceBtnClick(Sender: TObject);
    procedure OutBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RepeatBtnClick(Sender: TObject);
    procedure mEditChange(Sender: TObject);
    procedure nEditChange(Sender: TObject);
    procedure S1EditChange(Sender: TObject);
    procedure extensionBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure Exps2(var S2B, S2G, S2R:integer; I, J, nn, mm: integer);
    procedure FijS1S2(I, J, n, m: integer);
    procedure S1mnCheck;
    procedure S2ExpdArray(S2: double);
    procedure S1ExDArray(n, m: Integer; S1: Double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;


implementation

{$R *.dfm}
var
  Inputbitmap       : Tbitmap;                    // t@C͗prbg}bv

  InMatB          : array of array of Byte;       // ̓f[^[pz
  InMatG          : array of array of Byte;
  InMatR          : array of array of Byte;

  InputMatB       : array of array of Byte;       // }XNvZpgz
  InputMatG       : array of array of Byte;
  InputMatR       : array of array of Byte;

  OutputMatB      : array of array of Byte;       // }XNvZo͗pz
  OutputMatG      : array of array of Byte;
  OutputMatR      : array of array of Byte;

  GHeight, GWidth : Integer;                      // ͉摜TCY

  VRect           : TRect;                        // 摜\g

  S2ExpD          : array of Integer;             // s2bNAbve[u
  S1ExpD          : array of array of Integer;    // s1bNAbve[u

  DMM, DNN        : Integer;                      // m*2, n*2



const
  FileOpenFilter = 'Image File|*.jpg;*.jpeg;*.tif;*.tiff;*.png;*.gif;*.bmp;*.wdp' +
                   '|*.Jpg|*.jpg' +
                   '|*.Tif|*.tif' +
                   '|*.Png|*.png' +
                   '|*.Gif|*.gif' +
                   '|*.Bmp|*.bmp' +
                   '|*.Wdp|*.wdp';

  S2MAX         = 512;                                  // PxW 512 ܂łƂ܂
  BISU          = 1000;                                 // vZ̈1000{܂

//***************************************************
// KEVAe[uz쐬
// S1  1
// }XNl 0`m 0`n
//***************************************************
procedure TForm1.S1ExDArray(n, m: Integer; S1: Double);
var
  II, JJ: Integer;
begin
  for II := 0 to m do
    for JJ := 0 to n do
      S1ExpD[II, JJ] := Round((Exp(-(II * II + JJ * JJ) / (2 * S1 * S1))) * BISU);
end;

//******************************************
// Pxe[uz쐬
// dX ͍l S2   2
// dx  0`255
//******************************************
procedure TForm1.S2ExpdArray(S2: double);
var
  dX      : integer;
begin
  setlength(S2ExpD, MAXBYTE + 1);
  for dX := 0 to MAXBYTE do
    S2ExpD[dX] := Round(Exp(-(dX * dX / 2 / S2 / S2)) * BISU);
end;

//***************************************************************
// ␳lvZ
// 傫قǁAlȂ܂
// [̏ꍇ l P
// PxW2(S2) 傫ȂƁAl傫Ȃ܂
//***************************************************************
procedure TForm1.Exps2(var S2B, S2G, S2R:integer; I, J, nn, mm: integer);
var
  KinB    : Integer;
  KinG    : Integer;
  KinR    : Integer;
  IP, JP  : Integer;
begin
  IP    := I + nn;
  JP    := J + mm;
  KinB  := abs(InputMatB[I, J] - InputMatB[IP, JP]);    // ȂvZ
  KinG  := abs(InputMatG[I, J] - InputMatG[IP, JP]);
  KinR  := abs(InputMatR[I, J] - InputMatR[IP, JP]);
  S2B := S2ExpD[KinB];                                  // z񂩂l擾
  S2G := S2ExpD[KinG];
  S2R := S2ExpD[KinR];
end;

//***********************************************************
// g̈\
// DMM = m   DNN = n
// }XNvZ̈׊gꂽ܂߂ĕ\܂
//***********************************************************
procedure TForm1.extensionBtnClick(Sender: TObject);
var
  bitmap :  Tbitmap;
  PD     :  PbyteArray;
  WD     :  Integer;
  XX, YY :  Integer;
begin
  // gf[^[\
  bitmap := Tbitmap.Create;
  bitmap.PixelFormat := pf24bit;
  bitmap.Height := GHeight + DNN;
  bitmap.Width := GWidth + DMM;
  for YY := 0 to GHeight + DNN -1 do begin
    PD := bitmap.ScanLine[YY];
    for XX := 0 to GWidth + DMM -1 do begin
      WD := XX * 3;
      PD[WD    ] := InputMatB[YY , XX];
      PD[WD + 1] := InputMatG[YY , XX];
      PD[WD + 2] := InputMatR[YY , XX];
    end;
  end;
  Image1.Canvas.StretchDraw(VRect, bitmap);          // o͘gɕϔ{o
  bitmap.Free;
end;

//***************************************************************
// wW lvZ }XN
//***************************************************************
procedure TForm1.FijS1S2(I, J, n, m: integer);
var
  MM, NN  : integer;
  exp1    : integer;
  HI, WJ  : integer;
  IP, JP  : Integer;
  eSB, eSG, eSR : Integer;

  StopB, SbotB: Int64;                            // evl I[o[t[̂1nt64
  StopG, SbotG: Int64;
  StopR, SbotR: Int64;

  S2B: Integer;                                   // ␳l
  S2G: Integer;
  S2R: Integer;
begin
  StopB := 0;                                     // evNAOF
  StopG := 0;
  StopR := 0;
  SbotB := 0;
  SbotG := 0;
  SbotR := 0;
  HI := I + n;                                    // }XNTCYɉČf[^[gĂ̂ŔanVtg܂
  WJ := J + m;                                    // }XNTCYɉČf[^[gĂ̂ŔamVtg܂
  for MM := -m to m do
    for NN  := -n to n do begin
      Exps2(S2B, S2G, S2R, HI, WJ, NN, MM);       // ␳l S2B S2G S2R vZ
      exp1  := S1ExpD[abs(MM), abs(NN)];          // KEVA}XNl z񂩂}XNlo
      eSB   := exp1 * S2B;                        // }XNl悶ĕ␳WvZ
      eSG   := exp1 * S2G;
      eSR   := exp1 * S2R;
      IP    := HI + NN;                           // z̈ʒu c
      JP    := WJ + MM;                           // z̈ʒu 
      StopB := StopB + InputMatB[IP, JP] * eSB;   // 摜̒lɕ␳W悶Ẵ}XNWł̒lɂAv߂܂
      SbotB := SbotB + eSB;                       // ␳W̒lv܂B
      StopG := StopG + InputMatG[IP, JP] * eSG;
      SbotG := SbotG + eSG;
      StopR := StopR + InputMatR[IP, JP] * eSR;
      SbotR := SbotR + eSR;
  end;
  OutputMatB[ I, J] := StopB div SbotB;           // 摜␳lv}XNlvŊāAK
  OutputMatG[ I, J] := StopG div SbotG;
  OutputMatR[ I, J] := StopR div SbotR;
end;

//*****************************************************************
// oCe}XNvZ
//*****************************************************************
procedure TForm1.bilateralBtnClick(Sender: TObject);
var
  m, n          : Integer;
  S1            : Double;
  S2            : Double;
  XX, YY        : Integer;
  bitmap        : Tbitmap;
  PD            : PByteArray;
  WD            : Integer;
begin
  Val(medit.Text, m, XX);
  if XX <> 0 then begin
    Application.MessageBox('}XNTCY m ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if m <= 0 then begin
    Application.MessageBox('}XN m ̒l[́A[ȉłB','',0);
    exit;
  end;
  if m >= GWidth then begin
    Application.MessageBox('}XN m ̒l傫܂łB','',0);
    exit;
  end;
  Val(nedit.Text, n, XX);
  if XX <> 0 then begin
    Application.MessageBox('}XNTCY n ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if n <= 0 then begin
    Application.MessageBox('}XN  ̒l[́A[ȉłB','',0);
    exit;
  end;
  if n >= GHeight then begin
    Application.MessageBox('}XN n ̒l傫܂łB','',0);
    exit;
  end;
  Val(S1edit.Text, S1, XX);
  if XX <> 0 then begin
    Application.MessageBox('KEVA 1 ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if S1 <= 0 then begin
    Application.MessageBox('KEVA 1 ̒l[́A[ȉłB','',0);
    exit;
  end;
  Val(S2edit.Text, S2, XX);
  if XX <> 0 then begin
    Application.MessageBox('Pxl 2 ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if S2 < 1 then begin
    Application.MessageBox('Px 2 ̒lPȉłB','',0);
    exit;
  end;
  if S2 > S2MAX then begin
    Application.MessageBox('Px 2 ̒l傫܂A512 ܂łł','',0);
    exit;
  end;
  bilateralBtn.Enabled := False;

  // KEVA}XNz쐬
  SetLength(S1ExpD, m + 1, n + 1);
  S1ExDArray(n, m, S1);               // }XNz쐬
  S2ExpdArray(S2);                    // Pxe[uz쐬


  // }XLOvZׁ̈AzTCY̊g
  DMM := m * 2;       // DMM, DNN g̈p
  DNN := n * 2;

  SetLength(InputMatB, GHeight + DNN, GWidth + DMM);
  SetLength(InputMatG, GHeight + DNN, GWidth + DMM);
  SetLength(InputMatR, GHeight + DNN, GWidth + DMM);
  // l̃Rs[ gz̒ɃRs[
  for YY := n to GHeight + n - 1 do
    for XX := m To GWidth + m - 1 do begin
      InputMatB[YY, XX] := InMatB[YY - n, XX - m];
      InputMatG[YY, XX] := InMatG[YY - n, XX - m];
      InputMatR[YY, XX] := InMatR[YY - n, XX - m];
    end;
  // ̊g
  for YY := 0 to GHeight + 2 * n -1 do begin
    for XX :=  m downto 1 do begin
      InputMatB[YY, m - XX] := InputMatB[YY, m + XX];
      InputMatG[YY, m - XX] := InputMatG[YY, m + XX];
      InputMatR[YY, m - XX] := InputMatR[YY, m + XX];
    end;
  end;
  // E̊g
  for YY := 0 to GHeight + 2 * n -1 do begin
    for XX := m downto 1 do begin
      InputMatB[YY, GWidth + m  - 1 + XX] := InputMatB[YY, GWidth + m - 1 - XX];
      InputMatG[YY, GWidth + m  - 1 + XX] := InputMatG[YY, GWidth + m - 1 - XX];
      InputMatR[YY, GWidth + m  - 1 + XX] := InputMatR[YY, GWidth + m - 1 - XX];
    end;
  end;
  // 㑤̊g
  for XX := 0 to GWidth + 2 * m -1 do begin
    for YY :=  n downto 1 do begin
      InputMatB[n - YY, XX] := InputMatB[n + YY, XX];
      InputMatG[n - YY, XX] := InputMatG[n + YY, XX];
      InputMatR[n - YY, XX] := InputMatR[n + YY, XX];
    end;
  end;
  // ̊g
  for XX := 0 to GWidth + 2 * m -1 do begin
    for YY := n downto 1 do begin
      InputMatB[GHeight + n  - 1 + YY, XX] := InputMatB[GHeight + n - 1 - YY, XX];
      InputMatG[GHeight + n  - 1 + YY, XX] := InputMatG[GHeight + n - 1 - YY, XX];
      InputMatR[GHeight + n  - 1 + YY, XX] := InputMatR[GHeight + n - 1 - YY, XX];
    end;
  end;

  // o͗pzm
  SetLength(OutputMatB, GHeight, Gwidth);
  SetLength(OutputMatG, GHeight, Gwidth);
  SetLength(OutputMatR, GHeight, Gwidth);
  // oCetB^[vZ
  for YY := 0 to GHeight - 1 do
    for XX := 0 to Gwidth - 1 do begin
      FijS1S2(YY, XX, n, m);
    end;
  // vZʕ\
  bitmap := Tbitmap.Create;
  bitmap.PixelFormat := pf24bit;
  bitmap.Height := GHeight;
  bitmap.Width := GWidth;
  for YY := 0 to GHeight -1 do begin
    PD := bitmap.ScanLine[YY];
    for XX := 0 to GWidth -1 do begin
      WD := XX * 3;
      PD[WD    ] := OutputMatB[YY , XX];
      PD[WD + 1] := OutputMatG[YY , XX];
      PD[WD + 2] := OutputMatR[YY , XX];
    end;
  end;
  Image1.Canvas.StretchDraw(VRect, bitmap);               // o͘gɕϔ{o
  bitmap.Free;
  bilateralBtn.Enabled := True;
  OutBtn.Enabled := True;
  RepeatBtn.Enabled := True;
  extensionBtn.Enabled := True;
end;

//***************************************************
// t@CI[vƉ摜\
//***************************************************
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  XX, YY            : Integer;                            // for loop  GG |C^[vZp
  WIC               : TWICImage;
  IHeight, IWidth   : integer;
  PD                : PByteArray;
  WD                : Integer;
begin
  OpenPictureDialog1.Filter := FileOpenFilter;
  if OpenPictureDialog1.Execute then                      // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;
      try
        WIC.LoadFromFile(OpenPictureDialog1.FileName);
        GHeight := WIC.Height;
        GWidth  := WIC.Width;
        Inputbitmap.PixelFormat := pf24bit;               // 24rbgtH[}bg
        Inputbitmap.SetSize(GWidth, GHeight);
        Inputbitmap.Canvas.Draw(0, 0, WIC);               // tH[}bgϊ 24rbgtH[}bgɂ܂
      finally
        WIC.Free;
      end;
    end
    else exit;                                            // LZI
  SorceBtn.Enabled := False;
  OutBtn.Enabled := False;
  RepeatBtn.Enabled := False;
  IWidth  := Image1.Width;                                // o͐C[W1̕
  IHeight := Image1.Height;                               // o͐C[W1̍
  // zɓ͉摜Zbg
  SetLength(InMatB, GHeight, Gwidth);
  SetLength(InMatG, GHeight, Gwidth);
  SetLength(InMatR, GHeight, Gwidth);
  for YY := 0 to GHeight - 1 do begin
    PD := Inputbitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      WD := XX * 3;
      InMatB[YY, XX] := PD[WD    ];
      InMatG[YY, XX] := PD[WD + 1];
      InMatR[YY, XX] := PD[WD + 2];
    end;
  end;
  // ͉摜\
  VRect := Rect(0, 0, Image1.Width, Image1.Height);       // o͘gݒ
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnFace;
  Image1.Canvas.FillRect(VRect);                          // Canvas 摜
  if GHeight <= GWidth then                               // cɂo̓TCYݒ
    IHeight := Round(IWidth * GHeight / GWidth)
  else
    IWidth := Round(IHeight * GWidth / GHeight);
  VRect := Rect(0, 0, IWidth, IHeight);                   // o͘gݒ
  Image1.Canvas.StretchDraw(VRect, Inputbitmap);          // o͘gɕϔ{o
  bilateralBtn.Enabled := True;
  SorceBtn.Enabled := True;
end;

//*********************************************
// Nݒ
//*********************************************
procedure TForm1.FormCreate(Sender: TObject);
//var
//  SBitmap:  TBitmap;
begin
  SorceBtn.Enabled := False;
  OutBtn.Enabled := False;
  RepeatBtn.Enabled := False;
  Top := (Screen.Height - Height) div 2;
  Left := (Screen.Width - Width)  div 2;
  Inputbitmap :=  Tbitmap.Create;
{
  SBitmap := TBitmap.Create;
  try
    SBitmap.Height := 768;
    SBitmap.Width  := 768;
    Image1.Picture.Graphic := SBitmap;
  finally
    SBitmap.Free;
  end;
}
//  Image1.Width := 256;
//  Image1.height := 256;

  bilateralBtn.Enabled := False;
  extensionBtn.Enabled := False;
  S1mnCheck;                      // KEVA}XN̍ŏl̕\ }XN̊p̒l }XNOt\
end;

//********************************************
// Irbg}bv
//********************************************
procedure TForm1.FormDestroy(Sender: TObject);
begin
  Inputbitmap.Free;
end;

//***************************************************************************
// KEVA}XN̍ŏl̕\ }XN̊p̒l }XNOt\
//***************************************************************************
procedure TForm1.S1mnCheck;
var
  CH    : integer;
  m,  n : Integer;
  S1    : Double;
  Z0    : Integer;
  X , Y : Integer;
  H     : Double;
begin
  Val(medit.Text, m, CH);
  if CH <> 0 then exit;
  if m  <= 0 then  exit;
  Val(nedit.Text, n, CH);
  if CH <> 0 then exit;
  if n  <= 0 then exit;
  Val(S1edit.Text, S1, CH);
  if CH <> 0 then exit;
  if S1 <= 0 then  exit;
  // }XN̋̒lvZ܂ }XN̒ňԏl
  Z0 := Round((Exp(-(n * n + m * m) / (2 * S1 * S1))) * BISU);
  //  Z0 := Exps1(n, m, S1);
  Label2.Caption := '}XNŏĺ@' + IntTostr(Z0);
  // }XN̒lOt\
  Series1.Clear;
  X := round(sqrt(n * n + m * m) * 10);                 // Ίp̔̒ * 10ׂ͍vZOt炩ɂ
  for Y := -X to X do begin                             // aȂ̂-`+ƂAΊp̒vZ
    H := Y / 10;                                        // O10{Ă̂Ŗ{̒lɂ܂
    Z0 := Round((Exp(- H * H / (2 * S1 * S1))) * BISU); // }XN̒lvZ
    Series1.AddXY(H, Z0, '',clblack);                   // Otɒǉ
  end;
end;

//*************************************************
// a  ͕ύXɂ}XNp̍ŏl\
//*************************************************
procedure TForm1.mEditChange(Sender: TObject);
begin
  S1mnCheck;
end;

procedure TForm1.nEditChange(Sender: TObject);
begin
  S1mnCheck;
end;

procedure TForm1.S1EditChange(Sender: TObject);
begin
  S1mnCheck;
end;

//******************************************************
// 摜Ɣr邽߁Ao͉摜ĕ\
//******************************************************
procedure TForm1.OutBtnClick(Sender: TObject);
var
  Bitmap:  TBitmap;
  PD                : PByteArray;
  WD                : Integer;
  YY, XX            : Integer;
begin
  OutBtn.Enabled := False;
  bitmap := Tbitmap.Create;
  bitmap.PixelFormat := pf24bit;
  bitmap.Height := GHeight;
  bitmap.Width := GWidth;
  for YY := 0 to GHeight -1 do begin
    PD := bitmap.ScanLine[YY];
    for XX := 0 to GWidth -1 do begin
      WD := XX * 3;
      PD[WD    ] := OutputMatB[YY , XX];
      PD[WD + 1] := OutputMatG[YY , XX];
      PD[WD + 2] := OutputMatR[YY , XX];
    end;
  end;
  Image1.Canvas.StretchDraw(VRect, bitmap);             // o͘gɕϔ{o
  bitmap.Free;
  OutBtn.Enabled := True;
end;

//******************************************************
// o̓f[^[͔zɃRs[ČvZ܂
//******************************************************
procedure TForm1.RepeatBtnClick(Sender: TObject);
var
  YY, XX            : Integer;
begin
  RepeatBtn.Enabled := False;
  for YY := 0 to GHeight -1 do
    for XX := 0 to GWidth - 1 do begin
      InMatB[YY, XX] := OutputMatB[YY , XX];
      InMatG[YY, XX] := OutputMatG[YY , XX];
      InMatR[YY, XX] := OutputMatR[YY , XX];
    end;
  bilateralBtnClick(nil);
end;

//******************************************************
// 摜Ɣr邽߁A͉摜\
//******************************************************
procedure TForm1.SorceBtnClick(Sender: TObject);
begin
  SorceBtn.Enabled := False;
  Image1.Canvas.StretchDraw(VRect, Inputbitmap);          // o͘gɕϔ{o
  SorceBtn.Enabled := True;
end;

end.
